/*
  Adapted version of fsl_device_register.h
  Intention is to get the device specific flash configuration.
 */

#ifndef __FSL_DEVICE_REGISTERS_H__
#define __FSL_DEVICE_REGISTERS_H__

#if   defined (M4)     /* M4 */
  #define K32W042S1M2_M4_SERIES       /* required in fsl_flash.h */
#elif defined (M0P)     /* M0+ */
  #define K32W042S1M2_M0P_SERIES      /* required in fsl_flash.h */
#else
  #error "Core not selected!"
#endif

/* CPU specific feature definitions */
#include "K32W0x2_header.h"           /* Device header representating the device family */
#include "K32W0x2_features.h"
#include "K32W0x2_device.h"

#include "fsl_common.h"

#endif /* __FSL_DEVICE_REGISTERS_H__ */
